/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.anschrift.entity;

@javax.persistence.NamedQueries(
 {



   
 }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "ANSCHRIFT")
// @javax.persistence.IdClass(AnschriftPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Anschrift
extends AbstractAnschrift
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected Anschrift() {
    super();
  }
    public Anschrift(de.ivu.elect.jee.entity.customdata.CustomData customData){
                      if (customData != null && de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE != customData) {
          customData.setTechnicalEntity(this);
          customDataStorage = new de.ivu.elect.business.customdata.entity.CustomDataStorage(customData);
        }
            }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Anschrift(Anschrift original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "anschrift_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Anschrift")
    @javax.persistence.TableGenerator(name = "Anschrift", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Anschrift", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient AnschriftPK pkCache;

  @Override
  public AnschriftPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new AnschriftPK(getId());
    }

    return pkCache;
  }

  public static <E extends Anschrift> java.util.Map<AnschriftPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<AnschriftPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Anschrift> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedAnschriftArt = false;
          hasChangedBundesland = false;
          hasChangedHausnummer = false;
          hasChangedHausnummerzusatz = false;
          hasChangedOrt = false;
          hasChangedOrtsteil = false;
          hasChangedPlz = false;
          hasChangedPostfach = false;
          hasChangedStaat = false;
          hasChangedStrasse = false;
          hasChangedWohnungsnummer = false;
          hasChangedZustellanweisung = false;
  
      hasChangedCustomDataStorage = false;
  

                        
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ANSCHRIFT_ART", nullable = AnschriftConstants.ANSCHRIFT_ART_NULLABLE)
    
  protected de.ivu.elect.business.anschrift.entity.AnschriftArt anschriftArt =  de.ivu.elect.business.anschrift.entity.AnschriftArt.UNBEKANNT;

  @javax.persistence.Transient
  protected boolean hasChangedAnschriftArt = false;

  public boolean hasChangedAnschriftArt(){
    return hasChangedAnschriftArt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertAnschriftArt = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.anschrift.entity.AnschriftArt wertNachLadenAnschriftArt;
  
  /**
   * 
   *
   * getter for ANSCHRIFT.ANSCHRIFT_ART
   */
    @Override   public  de.ivu.elect.business.anschrift.entity.AnschriftArt getAnschriftArt() {
        return anschriftArt;
      }

  /**
   * 
   *
   * setter for ANSCHRIFT.ANSCHRIFT_ART
   *
   * @param anschriftArt
   */
  @Override   public void setAnschriftArt( de.ivu.elect.business.anschrift.entity.AnschriftArt anschriftArt) {

       resetTkCache();
                  de.ivu.elect.business.anschrift.entity.AnschriftArt anschriftArtInternal = anschriftArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.anschriftArt
      , anschriftArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAnschriftArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("anschriftArt");
      }


             if (!isSeitLadenVeraendertAnschriftArt) {
          isSeitLadenVeraendertAnschriftArt = thisAttributChanged;
         if (isSeitLadenVeraendertAnschriftArt){
           wertNachLadenAnschriftArt=this.anschriftArt;
         }
       }
      

       this.anschriftArt = anschriftArtInternal;

         }

        
  @javax.persistence.Column(name = "BUNDESLAND", nullable = AnschriftConstants.BUNDESLAND_NULLABLE, length=AnschriftConstants.BUNDESLAND_MAX_LENGTH)
        
  protected java.lang.String bundesland =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBundesland = false;

  public boolean hasChangedBundesland(){
    return hasChangedBundesland;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBundesland = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBundesland;
  
  /**
   * 
   *
   * getter for ANSCHRIFT.BUNDESLAND
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBundesland() {
        return bundesland;
      }

  /**
   * 
   *
   * setter for ANSCHRIFT.BUNDESLAND
   *
   * @param bundesland
   */
  @Override   public void setBundesland(@javax.annotation.Nullable  java.lang.String bundesland) {

       resetTkCache();
                  
                          java.lang.String bundeslandInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bundesland, AnschriftConstants.BUNDESLAND_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bundesland
      , bundeslandInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBundesland |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bundesland");
      }


             if (!isSeitLadenVeraendertBundesland) {
          isSeitLadenVeraendertBundesland = thisAttributChanged;
         if (isSeitLadenVeraendertBundesland){
           wertNachLadenBundesland=this.bundesland;
         }
       }
      

       this.bundesland = bundeslandInternal;

         }

        
  @javax.persistence.Column(name = "HAUSNUMMER", nullable = AnschriftConstants.HAUSNUMMER_NULLABLE, length=AnschriftConstants.HAUSNUMMER_MAX_LENGTH)
        
  protected java.lang.String hausnummer =  null;

  @javax.persistence.Transient
  protected boolean hasChangedHausnummer = false;

  public boolean hasChangedHausnummer(){
    return hasChangedHausnummer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertHausnummer = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenHausnummer;
  
  /**
   * 
   *
   * getter for ANSCHRIFT.HAUSNUMMER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getHausnummer() {
        return hausnummer;
      }

  /**
   * 
   *
   * setter for ANSCHRIFT.HAUSNUMMER
   *
   * @param hausnummer
   */
  @Override   public void setHausnummer(@javax.annotation.Nullable  java.lang.String hausnummer) {

       resetTkCache();
                  
                          java.lang.String hausnummerInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(hausnummer, AnschriftConstants.HAUSNUMMER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.hausnummer
      , hausnummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedHausnummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("hausnummer");
      }


             if (!isSeitLadenVeraendertHausnummer) {
          isSeitLadenVeraendertHausnummer = thisAttributChanged;
         if (isSeitLadenVeraendertHausnummer){
           wertNachLadenHausnummer=this.hausnummer;
         }
       }
      

       this.hausnummer = hausnummerInternal;

         }

        
  @javax.persistence.Column(name = "HAUSNUMMERZUSATZ", nullable = AnschriftConstants.HAUSNUMMERZUSATZ_NULLABLE, length=AnschriftConstants.HAUSNUMMERZUSATZ_MAX_LENGTH)
        
  protected java.lang.String hausnummerzusatz =  null;

  @javax.persistence.Transient
  protected boolean hasChangedHausnummerzusatz = false;

  public boolean hasChangedHausnummerzusatz(){
    return hasChangedHausnummerzusatz;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertHausnummerzusatz = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenHausnummerzusatz;
  
  /**
   * 
   *
   * getter for ANSCHRIFT.HAUSNUMMERZUSATZ
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getHausnummerzusatz() {
        return hausnummerzusatz;
      }

  /**
   * 
   *
   * setter for ANSCHRIFT.HAUSNUMMERZUSATZ
   *
   * @param hausnummerzusatz
   */
  @Override   public void setHausnummerzusatz(@javax.annotation.Nullable  java.lang.String hausnummerzusatz) {

       resetTkCache();
                  
                          java.lang.String hausnummerzusatzInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(hausnummerzusatz, AnschriftConstants.HAUSNUMMERZUSATZ_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.hausnummerzusatz
      , hausnummerzusatzInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedHausnummerzusatz |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("hausnummerzusatz");
      }


             if (!isSeitLadenVeraendertHausnummerzusatz) {
          isSeitLadenVeraendertHausnummerzusatz = thisAttributChanged;
         if (isSeitLadenVeraendertHausnummerzusatz){
           wertNachLadenHausnummerzusatz=this.hausnummerzusatz;
         }
       }
      

       this.hausnummerzusatz = hausnummerzusatzInternal;

         }

        
  @javax.persistence.Column(name = "ORT", nullable = AnschriftConstants.ORT_NULLABLE, length=AnschriftConstants.ORT_MAX_LENGTH)
        
  protected java.lang.String ort =  null;

  @javax.persistence.Transient
  protected boolean hasChangedOrt = false;

  public boolean hasChangedOrt(){
    return hasChangedOrt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertOrt = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenOrt;
  
  /**
   * 
   *
   * getter for ANSCHRIFT.ORT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getOrt() {
        return ort;
      }

  /**
   * 
   *
   * setter for ANSCHRIFT.ORT
   *
   * @param ort
   */
  @Override   public void setOrt(@javax.annotation.Nullable  java.lang.String ort) {

       resetTkCache();
                  
                          java.lang.String ortInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(ort, AnschriftConstants.ORT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ort
      , ortInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedOrt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ort");
      }


             if (!isSeitLadenVeraendertOrt) {
          isSeitLadenVeraendertOrt = thisAttributChanged;
         if (isSeitLadenVeraendertOrt){
           wertNachLadenOrt=this.ort;
         }
       }
      

       this.ort = ortInternal;

         }

        
  @javax.persistence.Column(name = "ORTSTEIL", nullable = AnschriftConstants.ORTSTEIL_NULLABLE, length=AnschriftConstants.ORTSTEIL_MAX_LENGTH)
        
  protected java.lang.String ortsteil =  null;

  @javax.persistence.Transient
  protected boolean hasChangedOrtsteil = false;

  public boolean hasChangedOrtsteil(){
    return hasChangedOrtsteil;
  }
  
  /**
   * 
   *
   * getter for ANSCHRIFT.ORTSTEIL
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getOrtsteil() {
        return ortsteil;
      }

  /**
   * 
   *
   * setter for ANSCHRIFT.ORTSTEIL
   *
   * @param ortsteil
   */
  @Override   public void setOrtsteil(@javax.annotation.Nullable  java.lang.String ortsteil) {

       resetTkCache();
                  
                          java.lang.String ortsteilInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(ortsteil, AnschriftConstants.ORTSTEIL_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ortsteil
      , ortsteilInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedOrtsteil |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ortsteil");
      }


      

       this.ortsteil = ortsteilInternal;

         }

        
  @javax.persistence.Column(name = "PLZ", nullable = AnschriftConstants.PLZ_NULLABLE, length=AnschriftConstants.PLZ_MAX_LENGTH)
        
  protected java.lang.String plz =  null;

  @javax.persistence.Transient
  protected boolean hasChangedPlz = false;

  public boolean hasChangedPlz(){
    return hasChangedPlz;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertPlz = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenPlz;
  
  /**
   * 
   *
   * getter for ANSCHRIFT.PLZ
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getPlz() {
        return plz;
      }

  /**
   * 
   *
   * setter for ANSCHRIFT.PLZ
   *
   * @param plz
   */
  @Override   public void setPlz(@javax.annotation.Nullable  java.lang.String plz) {

       resetTkCache();
                  
                          java.lang.String plzInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(plz, AnschriftConstants.PLZ_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.plz
      , plzInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPlz |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("plz");
      }


             if (!isSeitLadenVeraendertPlz) {
          isSeitLadenVeraendertPlz = thisAttributChanged;
         if (isSeitLadenVeraendertPlz){
           wertNachLadenPlz=this.plz;
         }
       }
      

       this.plz = plzInternal;

         }

        
  @javax.persistence.Column(name = "POSTFACH", nullable = AnschriftConstants.POSTFACH_NULLABLE, length=AnschriftConstants.POSTFACH_MAX_LENGTH)
        
  protected java.lang.String postfach =  null;

  @javax.persistence.Transient
  protected boolean hasChangedPostfach = false;

  public boolean hasChangedPostfach(){
    return hasChangedPostfach;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertPostfach = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenPostfach;
  
  /**
   * 
   *
   * getter for ANSCHRIFT.POSTFACH
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getPostfach() {
        return postfach;
      }

  /**
   * 
   *
   * setter for ANSCHRIFT.POSTFACH
   *
   * @param postfach
   */
  @Override   public void setPostfach(@javax.annotation.Nullable  java.lang.String postfach) {

       resetTkCache();
                  
                          java.lang.String postfachInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(postfach, AnschriftConstants.POSTFACH_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.postfach
      , postfachInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPostfach |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("postfach");
      }


             if (!isSeitLadenVeraendertPostfach) {
          isSeitLadenVeraendertPostfach = thisAttributChanged;
         if (isSeitLadenVeraendertPostfach){
           wertNachLadenPostfach=this.postfach;
         }
       }
      

       this.postfach = postfachInternal;

         }

        
  @javax.persistence.Column(name = "STAAT", nullable = AnschriftConstants.STAAT_NULLABLE, length=AnschriftConstants.STAAT_MAX_LENGTH)
        
  protected java.lang.String staat =  null;

  @javax.persistence.Transient
  protected boolean hasChangedStaat = false;

  public boolean hasChangedStaat(){
    return hasChangedStaat;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStaat = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenStaat;
  
  /**
   * 
   *
   * getter for ANSCHRIFT.STAAT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getStaat() {
        return staat;
      }

  /**
   * 
   *
   * setter for ANSCHRIFT.STAAT
   *
   * @param staat
   */
  @Override   public void setStaat(@javax.annotation.Nullable  java.lang.String staat) {

       resetTkCache();
                  
                          java.lang.String staatInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(staat, AnschriftConstants.STAAT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.staat
      , staatInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStaat |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("staat");
      }


             if (!isSeitLadenVeraendertStaat) {
          isSeitLadenVeraendertStaat = thisAttributChanged;
         if (isSeitLadenVeraendertStaat){
           wertNachLadenStaat=this.staat;
         }
       }
      

       this.staat = staatInternal;

         }

        
  @javax.persistence.Column(name = "STRASSE", nullable = AnschriftConstants.STRASSE_NULLABLE, length=AnschriftConstants.STRASSE_MAX_LENGTH)
        
  protected java.lang.String strasse =  null;

  @javax.persistence.Transient
  protected boolean hasChangedStrasse = false;

  public boolean hasChangedStrasse(){
    return hasChangedStrasse;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStrasse = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenStrasse;
  
  /**
   * 
   *
   * getter for ANSCHRIFT.STRASSE
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getStrasse() {
        return strasse;
      }

  /**
   * 
   *
   * setter for ANSCHRIFT.STRASSE
   *
   * @param strasse
   */
  @Override   public void setStrasse(@javax.annotation.Nullable  java.lang.String strasse) {

       resetTkCache();
                  
                          java.lang.String strasseInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(strasse, AnschriftConstants.STRASSE_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.strasse
      , strasseInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStrasse |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("strasse");
      }


             if (!isSeitLadenVeraendertStrasse) {
          isSeitLadenVeraendertStrasse = thisAttributChanged;
         if (isSeitLadenVeraendertStrasse){
           wertNachLadenStrasse=this.strasse;
         }
       }
      

       this.strasse = strasseInternal;

         }

        
  @javax.persistence.Column(name = "WOHNUNGSNUMMER", nullable = AnschriftConstants.WOHNUNGSNUMMER_NULLABLE, length=AnschriftConstants.WOHNUNGSNUMMER_MAX_LENGTH)
        
  protected java.lang.String wohnungsnummer =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWohnungsnummer = false;

  public boolean hasChangedWohnungsnummer(){
    return hasChangedWohnungsnummer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWohnungsnummer = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenWohnungsnummer;
  
  /**
   * 
   *
   * getter for ANSCHRIFT.WOHNUNGSNUMMER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getWohnungsnummer() {
        return wohnungsnummer;
      }

  /**
   * 
   *
   * setter for ANSCHRIFT.WOHNUNGSNUMMER
   *
   * @param wohnungsnummer
   */
  @Override   public void setWohnungsnummer(@javax.annotation.Nullable  java.lang.String wohnungsnummer) {

       resetTkCache();
                  
                          java.lang.String wohnungsnummerInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(wohnungsnummer, AnschriftConstants.WOHNUNGSNUMMER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wohnungsnummer
      , wohnungsnummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWohnungsnummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wohnungsnummer");
      }


             if (!isSeitLadenVeraendertWohnungsnummer) {
          isSeitLadenVeraendertWohnungsnummer = thisAttributChanged;
         if (isSeitLadenVeraendertWohnungsnummer){
           wertNachLadenWohnungsnummer=this.wohnungsnummer;
         }
       }
      

       this.wohnungsnummer = wohnungsnummerInternal;

         }

        
  @javax.persistence.Column(name = "ZUSTELLANWEISUNG", nullable = AnschriftConstants.ZUSTELLANWEISUNG_NULLABLE, length=AnschriftConstants.ZUSTELLANWEISUNG_MAX_LENGTH)
        
  protected java.lang.String zustellanweisung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedZustellanweisung = false;

  public boolean hasChangedZustellanweisung(){
    return hasChangedZustellanweisung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertZustellanweisung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenZustellanweisung;
  
  /**
   * 
   *
   * getter for ANSCHRIFT.ZUSTELLANWEISUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getZustellanweisung() {
        return zustellanweisung;
      }

  /**
   * 
   *
   * setter for ANSCHRIFT.ZUSTELLANWEISUNG
   *
   * @param zustellanweisung
   */
  @Override   public void setZustellanweisung(@javax.annotation.Nullable  java.lang.String zustellanweisung) {

       resetTkCache();
                  
                          java.lang.String zustellanweisungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(zustellanweisung, AnschriftConstants.ZUSTELLANWEISUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.zustellanweisung
      , zustellanweisungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedZustellanweisung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("zustellanweisung");
      }


             if (!isSeitLadenVeraendertZustellanweisung) {
          isSeitLadenVeraendertZustellanweisung = thisAttributChanged;
         if (isSeitLadenVeraendertZustellanweisung){
           wertNachLadenZustellanweisung=this.zustellanweisung;
         }
       }
      

       this.zustellanweisung = zustellanweisungInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu CustomDataStorage
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "CUSTOM_DATA_STORAGE_ID", referencedColumnName="CUSTOM_DATA_STORAGE_ID"))
  protected de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage;

  /**
   * 
   */
  @Override
  public void setCustomDataStorage(@javax.annotation.Nullable  de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.customDataStorage
    , customDataStorage);

    attributeChanged |= thisAttributChanged;

    hasChangedCustomDataStorage |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("customDataStorage");
    }

    this.customDataStorage = customDataStorage;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.customdata.entity.CustomDataStorage getCustomDataStorage(){
    return this.customDataStorage;
  }

  @javax.persistence.Transient
  protected boolean hasChangedCustomDataStorage = false;

  public boolean hasChangedCustomDataStorage(){
    return hasChangedCustomDataStorage;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Anschrift:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Anschrift other){
                             other.anschriftArt = this.anschriftArt;
                                other.bundesland = this.bundesland;
                                other.hausnummer = this.hausnummer;
                                other.hausnummerzusatz = this.hausnummerzusatz;
                                other.ort = this.ort;
                                other.ortsteil = this.ortsteil;
                                other.plz = this.plz;
                                other.postfach = this.postfach;
                                other.staat = this.staat;
                                other.strasse = this.strasse;
                                other.wohnungsnummer = this.wohnungsnummer;
                                other.zustellanweisung = this.zustellanweisung;
           
  other.setCustomDataStorage(this.getCustomDataStorage());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Anschrift.class)){
        copyEntityAttributesUsingSetter((Anschrift) other.castTo(Anschrift.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Anschrift: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Anschrift other){
               other.setAnschriftArt(this.anschriftArt);
                  other.setBundesland(this.bundesland);
                  other.setHausnummer(this.hausnummer);
                  other.setHausnummerzusatz(this.hausnummerzusatz);
                  other.setOrt(this.ort);
                  other.setOrtsteil(this.ortsteil);
                  other.setPlz(this.plz);
                  other.setPostfach(this.postfach);
                  other.setStaat(this.staat);
                  other.setStrasse(this.strasse);
                  other.setWohnungsnummer(this.wohnungsnummer);
                  other.setZustellanweisung(this.zustellanweisung);
           other.setCustomDataXml(this.getCustomDataXml());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Anschrift other){
                       if (hasChangedAnschriftArt) {
        other.setAnschriftArt(this.anschriftArt);
      }
                             if (hasChangedBundesland) {
        other.setBundesland(this.bundesland);
      }
                             if (hasChangedHausnummer) {
        other.setHausnummer(this.hausnummer);
      }
                             if (hasChangedHausnummerzusatz) {
        other.setHausnummerzusatz(this.hausnummerzusatz);
      }
                             if (hasChangedOrt) {
        other.setOrt(this.ort);
      }
                             if (hasChangedOrtsteil) {
        other.setOrtsteil(this.ortsteil);
      }
                             if (hasChangedPlz) {
        other.setPlz(this.plz);
      }
                             if (hasChangedPostfach) {
        other.setPostfach(this.postfach);
      }
                             if (hasChangedStaat) {
        other.setStaat(this.staat);
      }
                             if (hasChangedStrasse) {
        other.setStrasse(this.strasse);
      }
                             if (hasChangedWohnungsnummer) {
        other.setWohnungsnummer(this.wohnungsnummer);
      }
                             if (hasChangedZustellanweisung) {
        other.setZustellanweisung(this.zustellanweisung);
      }
             }




    /**
    * Hat die Entität überhaupt einen CustomDataStorage?
    */
    private boolean isCustomDataSupported() {
      return getCustomDataStorage()!=null;
    }

    @Override
    public de.ivu.elect.jee.entity.customdata.CustomData getCustomData() {
      if (isCustomDataSupported()) {
        de.ivu.elect.jee.entity.customdata.CustomData result = getCustomDataStorage().getCustomData();
        result.setTechnicalEntity(this); // Fachliche Entität bei jedem Zugriff setzen
        return result;
      }
      return de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE;
    }


    @Override
    @SuppressWarnings("unchecked")
    public <T extends de.ivu.elect.jee.entity.customdata.CustomData> T getCustomData(Class<T> clazz) {
      if (isCustomDataSupported()) {
        return (T) getCustomData();
      }
      throw new IllegalStateException("Entität Anschrift besitzt kein CustomDataStorage: "+this);
    }


    @Override
    public void updateCustomData() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().updateCustomData();
      }
    }


    public void clearCustomDataCache() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().clearCustomDataCache();
      }
    }

    public String getCustomDataXml(){
      if (isCustomDataSupported()) {
        return getCustomDataStorage().getCustomDataXml();
      }
      return "";
    }

    public void setCustomDataXml(String customDataXml){
      if (isCustomDataSupported()) {
        if (org.apache.commons.lang3.StringUtils.isBlank(customDataXml)) {
          if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
            throw new IllegalStateException("Entität Anschrift hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
          }
          // ELECTMUC-2581
          System.err.println("Entität Anschrift hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
        } else {
          getCustomDataStorage().setCustomDataXml(customDataXml);
        }
        clearCustomDataCache(); // WASDE-1131
      } else {
       if (org.apache.commons.lang3.StringUtils.isNotBlank(customDataXml)) {
         if (customDataXml.endsWith("EmptyCustomData/>")) {
            // Abwärtskompatibilität...alles gut, die alten, leeren CustomDataObjekte...
         } else {
           if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
             throw new IllegalStateException("Entität Anschrift hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
           }
           // ELECT-5122
           System.err.println("Entität Anschrift hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
         }
       }
      }
    }

    public boolean hasChangedCustomDataXml() {
      if (isCustomDataSupported()) {
        return getCustomDataStorage().hasChangedCustomDataXml();
      }
      return false;
    }


    @javax.persistence.Transient
    private transient AnschriftTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public AnschriftTK getAnschriftTK(){
    if (tkCache==null) {
    tkCache = new AnschriftTK(

getHausnummer()
, getOrt()
, getPlz()
, getStrasse()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getAnschriftTK();
    }

  @Override
  public AnschriftUK getUk(){
    return getAnschriftUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Anschrift.class;
  }

public AnschriftUK getAnschriftUK(){

   return  new AnschriftUK(



  );
}

  @javax.persistence.Transient
  private transient AnschriftProperties properties;

  public AnschriftProperties getProperties(){
    if (properties == null) {
      properties = new AnschriftProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public AnschriftProperties getAnschriftProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return AnschriftConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(AnschriftConstants.MESSAGE_KEY_ANSCHRIFT_ART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(AnschriftConstants.MESSAGE_KEY_ANSCHRIFT_ART_EINZAHL);

        anschriftArt =
     (de.ivu.elect.business.anschrift.entity.AnschriftArt) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(AnschriftConstants.MESSAGE_KEY_BUNDESLAND_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(AnschriftConstants.MESSAGE_KEY_BUNDESLAND_EINZAHL);

        bundesland =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(AnschriftConstants.MESSAGE_KEY_HAUSNUMMER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(AnschriftConstants.MESSAGE_KEY_HAUSNUMMER_EINZAHL);

        hausnummer =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(AnschriftConstants.MESSAGE_KEY_HAUSNUMMERZUSATZ_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(AnschriftConstants.MESSAGE_KEY_HAUSNUMMERZUSATZ_EINZAHL);

        hausnummerzusatz =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(AnschriftConstants.MESSAGE_KEY_ORT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(AnschriftConstants.MESSAGE_KEY_ORT_EINZAHL);

        ort =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                    
      if (werteVorher.containsKey(AnschriftConstants.MESSAGE_KEY_PLZ_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(AnschriftConstants.MESSAGE_KEY_PLZ_EINZAHL);

        plz =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(AnschriftConstants.MESSAGE_KEY_POSTFACH_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(AnschriftConstants.MESSAGE_KEY_POSTFACH_EINZAHL);

        postfach =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(AnschriftConstants.MESSAGE_KEY_STAAT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(AnschriftConstants.MESSAGE_KEY_STAAT_EINZAHL);

        staat =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(AnschriftConstants.MESSAGE_KEY_STRASSE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(AnschriftConstants.MESSAGE_KEY_STRASSE_EINZAHL);

        strasse =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(AnschriftConstants.MESSAGE_KEY_WOHNUNGSNUMMER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(AnschriftConstants.MESSAGE_KEY_WOHNUNGSNUMMER_EINZAHL);

        wohnungsnummer =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(AnschriftConstants.MESSAGE_KEY_ZUSTELLANWEISUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(AnschriftConstants.MESSAGE_KEY_ZUSTELLANWEISUNG_EINZAHL);

        zustellanweisung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertAnschriftArt) {
      result.put(AnschriftConstants.MESSAGE_KEY_ANSCHRIFT_ART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenAnschriftArt , anschriftArt));
    }
                            if (isSeitLadenVeraendertBundesland) {
      result.put(AnschriftConstants.MESSAGE_KEY_BUNDESLAND_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBundesland , bundesland));
    }
                            if (isSeitLadenVeraendertHausnummer) {
      result.put(AnschriftConstants.MESSAGE_KEY_HAUSNUMMER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenHausnummer , hausnummer));
    }
                            if (isSeitLadenVeraendertHausnummerzusatz) {
      result.put(AnschriftConstants.MESSAGE_KEY_HAUSNUMMERZUSATZ_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenHausnummerzusatz , hausnummerzusatz));
    }
                            if (isSeitLadenVeraendertOrt) {
      result.put(AnschriftConstants.MESSAGE_KEY_ORT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenOrt , ort));
    }
                                                if (isSeitLadenVeraendertPlz) {
      result.put(AnschriftConstants.MESSAGE_KEY_PLZ_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenPlz , plz));
    }
                            if (isSeitLadenVeraendertPostfach) {
      result.put(AnschriftConstants.MESSAGE_KEY_POSTFACH_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenPostfach , postfach));
    }
                            if (isSeitLadenVeraendertStaat) {
      result.put(AnschriftConstants.MESSAGE_KEY_STAAT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenStaat , staat));
    }
                            if (isSeitLadenVeraendertStrasse) {
      result.put(AnschriftConstants.MESSAGE_KEY_STRASSE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenStrasse , strasse));
    }
                            if (isSeitLadenVeraendertWohnungsnummer) {
      result.put(AnschriftConstants.MESSAGE_KEY_WOHNUNGSNUMMER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenWohnungsnummer , wohnungsnummer));
    }
                            if (isSeitLadenVeraendertZustellanweisung) {
      result.put(AnschriftConstants.MESSAGE_KEY_ZUSTELLANWEISUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenZustellanweisung , zustellanweisung));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertAnschriftArt = false;
      wertNachLadenAnschriftArt = null;
                          isSeitLadenVeraendertBundesland = false;
      wertNachLadenBundesland = null;
                          isSeitLadenVeraendertHausnummer = false;
      wertNachLadenHausnummer = null;
                          isSeitLadenVeraendertHausnummerzusatz = false;
      wertNachLadenHausnummerzusatz = null;
                          isSeitLadenVeraendertOrt = false;
      wertNachLadenOrt = null;
                                          isSeitLadenVeraendertPlz = false;
      wertNachLadenPlz = null;
                          isSeitLadenVeraendertPostfach = false;
      wertNachLadenPostfach = null;
                          isSeitLadenVeraendertStaat = false;
      wertNachLadenStaat = null;
                          isSeitLadenVeraendertStrasse = false;
      wertNachLadenStrasse = null;
                          isSeitLadenVeraendertWohnungsnummer = false;
      wertNachLadenWohnungsnummer = null;
                          isSeitLadenVeraendertZustellanweisung = false;
      wertNachLadenZustellanweisung = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "ANSCHRIFT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Anschrift";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(anschriftArt, this, AnschriftConstants.MESSAGE_KEY_ANSCHRIFT_ART_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(AnschriftConstants.BUNDESLAND_MAX_LENGTH ,  bundesland, this, AnschriftConstants.MESSAGE_KEY_BUNDESLAND_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(AnschriftConstants.HAUSNUMMER_MAX_LENGTH ,  hausnummer, this, AnschriftConstants.MESSAGE_KEY_HAUSNUMMER_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(AnschriftConstants.HAUSNUMMERZUSATZ_MAX_LENGTH ,  hausnummerzusatz, this, AnschriftConstants.MESSAGE_KEY_HAUSNUMMERZUSATZ_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(AnschriftConstants.ORT_MAX_LENGTH ,  ort, this, AnschriftConstants.MESSAGE_KEY_ORT_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(AnschriftConstants.ORTSTEIL_MAX_LENGTH ,  ortsteil, this, AnschriftConstants.MESSAGE_KEY_ORTSTEIL_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(AnschriftConstants.PLZ_MAX_LENGTH ,  plz, this, AnschriftConstants.MESSAGE_KEY_PLZ_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(AnschriftConstants.POSTFACH_MAX_LENGTH ,  postfach, this, AnschriftConstants.MESSAGE_KEY_POSTFACH_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(AnschriftConstants.STAAT_MAX_LENGTH ,  staat, this, AnschriftConstants.MESSAGE_KEY_STAAT_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(AnschriftConstants.STRASSE_MAX_LENGTH ,  strasse, this, AnschriftConstants.MESSAGE_KEY_STRASSE_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(AnschriftConstants.WOHNUNGSNUMMER_MAX_LENGTH ,  wohnungsnummer, this, AnschriftConstants.MESSAGE_KEY_WOHNUNGSNUMMER_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(AnschriftConstants.ZUSTELLANWEISUNG_MAX_LENGTH ,  zustellanweisung, this, AnschriftConstants.MESSAGE_KEY_ZUSTELLANWEISUNG_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
